//Authors: Ates Akaydn, M.Bugra Yildiz
// Teapot Shader
// Date: 26.11.2011

//#version 140

//INPUT

//Texture Parameters
uniform sampler2D diffuseTexture; //Diffuse Texture
uniform sampler2D specularTexture; //Specular Map
uniform sampler2D ambientTexture; //Ambient Map
uniform float tiling = float(1.0); //Amount of Tiling for all textures

//Interpolated parameters from vertex shader
varying vec3 iAmbientColor, iSpecularColor,  iTexCoord; //Interpolated output normal, eye direction and light direction vectors
varying vec4 iDiffuseColor;
//Main routine
void main()
{
	vec4 ambientTexColor = texture(ambientTexture, tiling * iTexCoord.xy);
	vec4 diffuseTexColor = texture(diffuseTexture, tiling * iTexCoord.xy);
	vec4 specularTexColor = texture(specularTexture, tiling * iTexCoord.xy);
		
	vec4 final_color = vec4(0.0,0.0,0.0,0.0);
	final_color.rgb = iAmbientColor * ambientTexColor.rgb;
	final_color.rgb += iDiffuseColor * diffuseTexColor.rgb;
	final_color.rgb += iSpecularColor * specularTexColor.rgb;
	final_color.a = iDiffuseColor.a;
	
	gl_FragColor = clamp(final_color, 0.0, 1.0);	

}